<script lang="ts">
import { defineComponent } from "vue";
import type { PropType } from "vue";

export type BarreDef = {
  startString: number;
  endString: number;
  yOffset: number;
  fret: number;
};

export default defineComponent({
  props: {
    barres: {
      type: Object as PropType<Array<BarreDef>>,
    },
  },
  computed: {
    dPaths() {
      function barreToDPath(def: BarreDef) {
        // draw a barre (curved line), starts 3 units earlier than string
        const xStart = 7 + def.startString * 18;
        // length is number of strings + 4 units extra each side
        const xLength = (def.endString - def.startString) * 18 + 6;
        const xMiddle = Math.ceil(xLength / 2);
        // start behind the fret line
        // account for the nut being 2 units thicker
        const yStart = def.fret === 1 ? def.yOffset - 13 : def.yOffset - 12;
        // slighly bigger curve with more strings spanned
        const curveAmount = 3 + (def.endString - def.startString) * 2;
        return (
          "M " +
          xStart +
          " " +
          yStart +
          " q " +
          xMiddle +
          " -" +
          curveAmount +
          " " +
          xLength +
          " 0"
        );
      }
      return this.barres === undefined ? [] : this.barres.map(barreToDPath);
    },
  },
});
</script>
<template>
  <path v-for="(d, key) in dPaths" class="barre" :d="d" :key="key" />
</template>
<style scoped>
.barre {
  fill: none;
  stroke: #787c7e;
  stroke-linecap: round;
  stroke-width: 1.2;
  transition: all 0.3s;
}
</style>
